# Copyright (c) 2012-2019, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.
#
# *** Do not modify - this file is autogenerated ***
# Resource specification version: 8.1.0


from . import AWSObject
from . import AWSProperty
from .validators import integer


class RoutingStrategy(AWSProperty):
    props = {
        'FleetId': (basestring, False),
        'Message': (basestring, False),
        'Type': (basestring, True),
    }


class Alias(AWSObject):
    resource_type = "AWS::GameLift::Alias"

    props = {
        'Description': (basestring, False),
        'Name': (basestring, True),
        'RoutingStrategy': (RoutingStrategy, True),
    }


class S3Location(AWSProperty):
    props = {
        'Bucket': (basestring, True),
        'Key': (basestring, True),
        'ObjectVersion': (basestring, False),
        'RoleArn': (basestring, True),
    }


class Build(AWSObject):
    resource_type = "AWS::GameLift::Build"

    props = {
        'Name': (basestring, False),
        'OperatingSystem': (basestring, False),
        'StorageLocation': (S3Location, False),
        'Version': (basestring, False),
    }


class CertificateConfiguration(AWSProperty):
    props = {
        'CertificateType': (basestring, True),
    }


class IpPermission(AWSProperty):
    props = {
        'FromPort': (integer, True),
        'IpRange': (basestring, True),
        'Protocol': (basestring, True),
        'ToPort': (integer, True),
    }


class ResourceCreationLimitPolicy(AWSProperty):
    props = {
        'NewGameSessionsPerCreator': (integer, False),
        'PolicyPeriodInMinutes': (integer, False),
    }


class ServerProcess(AWSProperty):
    props = {
        'ConcurrentExecutions': (integer, True),
        'LaunchPath': (basestring, True),
        'Parameters': (basestring, False),
    }


class RuntimeConfiguration(AWSProperty):
    props = {
        'GameSessionActivationTimeoutSeconds': (integer, False),
        'MaxConcurrentGameSessionActivations': (integer, False),
        'ServerProcesses': ([ServerProcess], False),
    }


class Fleet(AWSObject):
    resource_type = "AWS::GameLift::Fleet"

    props = {
        'BuildId': (basestring, False),
        'CertificateConfiguration': (CertificateConfiguration, False),
        'Description': (basestring, False),
        'DesiredEC2Instances': (integer, False),
        'EC2InboundPermissions': ([IpPermission], False),
        'EC2InstanceType': (basestring, True),
        'FleetType': (basestring, False),
        'InstanceRoleARN': (basestring, False),
        'LogPaths': ([basestring], False),
        'MaxSize': (integer, False),
        'MetricGroups': ([basestring], False),
        'MinSize': (integer, False),
        'Name': (basestring, True),
        'NewGameSessionProtectionPolicy': (basestring, False),
        'PeerVpcAwsAccountId': (basestring, False),
        'PeerVpcId': (basestring, False),
        'ResourceCreationLimitPolicy': (ResourceCreationLimitPolicy, False),
        'RuntimeConfiguration': (RuntimeConfiguration, False),
        'ScriptId': (basestring, False),
        'ServerLaunchParameters': (basestring, False),
        'ServerLaunchPath': (basestring, False),
    }
